import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono

fs, s0 = wave_read_16bit_mono('distortion(input).wav')
length_of_s = len(s0)

gain = 100
level = 0.5

s1 = np.zeros(length_of_s)
for n in range(length_of_s):
    s1[n] = np.tanh(5 * s0[n] * gain / 2)

s1 /= np.max(np.abs(s1))
s1 *= level

wave_write_16bit_mono(fs, s1.copy(), 'distortion(output).wav')
