import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono

fs, s0 = wave_read_16bit_mono('flanger(input).wav')
length_of_s = len(s0)

d = fs * 0.002
depth = fs * 0.002
rate = 0.5

x = 0
s1 = np.zeros(length_of_s)
for n in range(length_of_s):
    s1[n] = s0[n]
    tau = d + depth * np.sin(2 * np.pi * x)
    delta = rate / fs
    x += delta
    if x >= 1:
        x -= 1

    t = n - tau
    m = int(t)
    p = t - m

    if m >= 0 and m + 1 < length_of_s:
        s1[n] += (p * s1[m + 1] + (1 - p) * s1[m]) * 0.7

master_volume = 0.9
s1 /= np.max(np.abs(s1))
s1 *= master_volume

wave_write_16bit_mono(fs, s1.copy(), 'feedback_flanger(output).wav')
