import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono

fs, s0 = wave_read_16bit_mono('reverb(input).wav')
length_of_s = len(s0)

a = 0.7
d = fs * 0.05
repeat = 30

s1 = np.zeros(length_of_s)
for n in range(length_of_s):
    s1[n] = s0[n]
    for i in range(1, repeat + 1):
        m = int(n - d * i)
        if m >= 0:
            s1[n] += s0[m] * np.power(a, i)

master_volume = 0.9
s1 /= np.max(np.abs(s1))
s1 *= master_volume

wave_write_16bit_mono(fs, s1.copy(), 'reverb(output).wav')
