import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono

fs, s0 = wave_read_16bit_mono('tremolo(input).wav')
length_of_s = len(s0)

depth = 0.5
rate = 5

x = 0
s1 = np.zeros(length_of_s)
for n in range(length_of_s):
    a = 1 + depth * np.sin(2 * np.pi * x)
    delta = rate / fs
    x += delta
    if x >= 1:
        x -= 1

    s1[n] = s0[n] * a

master_volume = 0.9
s1 /= np.max(np.abs(s1))
s1 *= master_volume

wave_write_16bit_mono(fs, s1.copy(), 'tremolo(output).wav')
