import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono
from window_function import Hanning_window

fs, s0 = wave_read_16bit_mono('synth(input).wav')
length_of_s0 = len(s0)

fs, s1 = wave_read_16bit_mono('vocal(input).wav')
length_of_s1 = len(s1)

s2 = np.zeros(length_of_s0)

d = np.zeros(length_of_s1)
d[0] = 0
for n in range(1, length_of_s1):
    d[n] = s1[n] - 0.98 * s1[n - 1]

for n in range(length_of_s1):
    s1[n] = d[n]

N = 4096

x = np.zeros(N)
b = np.zeros(N)
w = Hanning_window(N)
Y = np.zeros(N, dtype = np.complex)

number_of_frame = int((length_of_s0 - N / 2) / (N / 2))

band_width = 8
number_of_band = int(N / 2 / band_width)

for frame in range(number_of_frame):
    offset = int(N / 2) * frame
    for n in range(N):
        x[n] = s0[offset + n] * w[n]
        b[n] = s1[offset + n] * w[n]

    X = np.fft.fft(x, N)
    B = np.abs(np.fft.fft(b, N))

    for band in range(number_of_band):
        offset = band_width * band
        a = 0
        for k in range(band_width):
            a += B[offset + k]

        a /= band_width
        for k in range(band_width):
            B[offset + k] = a

    B[0] = 0
    B[int(N / 2)] = 0
    for k in range(1, int(N / 2)):
        B[N - k] = B[k]

    for k in range(N):
        Y[k] = X[k] * B[k]

    y = np.real(np.fft.ifft(Y, N))

    offset = int(N / 2) * frame
    for n in range(N):
        s2[offset + n] += y[n]

master_volume = 0.9
s2 /= np.max(np.abs(s2))
s2 *= master_volume

wave_write_16bit_mono(fs, s2.copy(), 'vocoder(output).wav')
