import numpy as np
from wave_file import wave_read_16bit_mono
from wave_file import wave_write_16bit_mono
from biquad_filter import BPF

fs, s0 = wave_read_16bit_mono('wah(input).wav')
length_of_s = len(s0)

depth = 800
rate = 1

x = 0
s1 = np.zeros(length_of_s)
for n in range(length_of_s):
    fc = 1000 + depth * np.sin(2 * np.pi * x)
    delta = rate / fs
    x += delta
    if x >= 1:
        x -= 1

    Q = 2
    a, b = BPF(fs, fc, Q)
    for m in range(0, 3):
        if n - m >= 0:
            s1[n] += b[m] * s0[n - m]

    for m in range(1, 3):
        if n - m >= 0:
            s1[n] += -a[m] * s1[n - m]

master_volume = 0.9
s1 /= np.max(np.abs(s1))
s1 *= master_volume

wave_write_16bit_mono(fs, s1.copy(), 'wah(output).wav')
